.\"
.\" Copyright (c) 2004 Gordon D. Carrie.  All rights reserved.
.\" 
.\" Licensed under the Open Software License version 2.1
.\" 
.\" Please address questions and feedback to user0@tkgeomap.org
.\" 
.\" @(#) $Id: tclgeomap.n,v 1.16 2007/06/26 21:49:29 tkgeomap Exp $
.\"
.TH tclgeomap n 2 Tcl "Tcl Extensions tclgeomap"
.SH NAME
tclgeomap, georadius, latlonok, mapptok, lonbtwn, gclcross, rotatpt, scalept, domnlat, domnlon, domnlonpt, gwchlon, gwchpt, dmstodec, dectodm, dectodms, cartg, centroid, projection, lnarr, place \- commands for manipulating geographic data in Tcl.
.SH VERSION
2
.SH SYNOPSIS
.nf
\fBpackage require tclgeomap\fR ?\fB2\fR?
.sp
\fBgeomap::version\fR
\fBgeomap::georadius\fR ?\fIradius\fR? \fIunit\fR
\fBgeomap::latlonok\fR \fI{lat lon}\fR
\fBgeomap::mapptok\fR \fI{abscissa ordinate}\fR
\fBgeomap::lonbtwn\fR \fIlon {lon1 lon2}\fR
\fBgeomap::gclcross\fR \fIl1p1 l1p2 l2p1 l2p2\fR
\fBgeomap::rotatpt\fR \fI{abs ord} theta\fR
\fBgeomap::scalept\fR \fI{abs ord} factor\fR
\fBgeomap::domnlat\fR \fIlat\fR
\fBgeomap::domnlon\fR \fIlon rlon\fR
\fBgeomap::domnlonpt\fR \fI{lat lon} rlon\fR
\fBgeomap::gwchlon\fR \fIlon\fR
\fBgeomap::gwchpt\fR \fI{lat lon}\fR
\fBgeomap::dmstodec\fR \fI{deg ?min ?sec?? \fBN\fRor\fBS\fI deg ?min ?sec?? \fBW\fRor\fBE\fI}\fR
\fBgeomap::dectodm\fR \fIdeg\fROR\fI{lat lon}\fR
\fBgeomap::dectodms\fR \fIdeg\fROR\fI{lat lon}\fR
\fBgeomap::cartg\fR \fI{1:XXXXXXX}\fROR\fIdoubleValue\fR
\fBgeomap::centroid\fR \fIpoint_list\fR
.sp
\fBgeomap::time\fR \fBjul_to_cal\fR {\fIjulian_day second\fR}
\fBgeomap::time\fR \fBcal_to_jul\fR {\fIyear month day hour minute second\fR}
\fBgeomap::time\fR \fBincr\fR {\fIyear month day hour minute second\fR} \fIseconds\fR
\fBgeomap::time\fR \fBcmp\fR \fItime1\fR \fItime2\fR
\fBgeomap::time\fR \fBdiff\fR \fItime1\fR \fItime2\fR
.sp
\fBgeomap::projection\fR \fIprojType\fR ?\fIoptions\fR?
\fIprojId\fR \fBset\fR \fIprojType\fR ?\fIoptions\fR?
\fIprojId\fR \fBrotation\fR ?\fIangle\fR?
\fIprojId\fR \fBinfo\fR
\fIprojId\fR \fBfmlatlon\fR \fI{lat lon}\fR
\fIprojId\fR \fBtolatlon\fR \fI{abscissa ordinate}\fR
.sp
\fBgeomap::lnarr fmlist\fR \fIlnArrName listValue\fR
\fBgeomap::lnarr fmascii\fR \fIlnArrName fileName\fR ?\fB-descrlen\fR \fIlen\fR? ?\fB-format\fR \fIformat\fR?
\fBgeomap::lnarr fmxdr\fR \fIlnArrName fileName\fR
\fBgeomap::lnarr fmbin\fR \fIlnArrName fileName\fR
\fIlnArrName\fR \fBtolist\fR
\fIlnArrName\fR \fBtoascii\fR \fIfileName\fR ?\fB-ptperln\fR \fIn\fR? ?\fB-format\fR \fIformat\fR?
\fIlnArrName\fR \fBtoxdr\fR \fIfileName\fR
\fIlnArrName\fR \fBtobin\fR \fIfileName\fR
\fIlnArrName\fR \fBinfo\fR
\fIlnArrName\fR \fBdescr\fR \fI?newDescriptor?\fR
\fIlnArrName\fR \fBcontainpt\fR \fIgeopoint\fR
.sp
\fBgeomap::place new\fR \fIplaceName {lat lon}\fR
\fBgeomap::place set\fR \fIplaceName ?{lat lon}?\fR
\fBgeomap::place distance\fR \fIplaceName\fROR\fI{lat lon} placeName\fROR\fI{lat lon} ?unit?\fR
\fBgeomap::place azrng\fR \fIplaceName\fROR\fI{lat lon} placeName\fROR\fI{lat lon} ?unit?\fR
\fBgeomap::place nearest\fR \fIplaceName\fROR\fI{lat lon} placeList\fR
\fBgeomap::place step\fR \fIplaceName\fROR\fI{lat lon} bearing range ?unit?\fR
\fBgeomap::place inrange\fR \fIplaceName\fROR\fI{lat lon} {range ?unit?} ?placeList?\fR
\fIplaceName\fR \fBset\fR \fI?{lat lon}?\fR
\fIplaceName\fR \fBnearest\fR \fIplaceList\fR
\fIplaceName\fR \fBstep\fR \fIbearing range ?unit?\fR
\fIplaceName\fR \fBinrange\fR \fI{range ?unit?} placeList\fR
.fi
.SH INTRODUCTION
The \fBtclgeomap\fR package adds Tcl commands for storing and manipulating
geographic data.  It includes commands for calculating geographic distances
and angles, applying common map projections, creating named places, and
creating sets of anonymous points.  Unless otherwise noted, angles, including
latitudes, longitudes, and great circle distances are measured in DEGREES, and
straight-line distances are measured in METERS.
.SH GENERAL GEOGRAPHY COMMANDS
.TP
\fBgeomap::version\fR
Prints version and copyright information.
.TP
\fBgeomap::georadius\fR ?\fIradius\fR? \fIunit\fR
Returns the radius of the Earth in \fIunit\fR, or sets the radius of the Earth
to value \fIradius\fR in unit \fIunit\fR.  \fIunit\fR must be one of \fBnmi\fR
(international standard nautical mile = 1852.0 m), \fBsmi\fR (statute mile =
1609.344 m), \fBkm\fR (kilometers), \fBmeters\fR (meters) or \fBcm\fR
(centimeters).
.TP
\fBgeomap::latlonok\fR \fI{lat lon}\fR
Returns true (\fB1\fR) if \fI{lat lon}\fR is a valid geographic point.  It
returns false (\fB0\fR) if \fI{lat lon}\fR is invalid, for example, if one
attempts to convert a projection point that is outside the projection domain.
.TP
\fBgeomap::mapptok\fR \fI{abscissa ordinate}\fR
Returns true (\fB1\fR) if \fI{abscissa ordinate}\fR is a valid map point,
otherwise it returns false (\fB0\fR).
.TP
\fBgeomap::lonbtwn\fR \fIlon {lon1 lon2}\fR
Returns true (\fB1\fR) if longitude \fIlon\fR is between longitudes \fIlon1\fR
and \fIlon2\fR, otherwise it returns false (\fB0\fR).  It correctly handles
intervals containing the International Dateline and other singularities.
.TP
\fBgeomap::gclcross\fR \fIl1p1 l1p2 l2p1 l2p2\fR
Returns the {lat lon} of the intersection of two great circles, given two
points on each great circle.  The great circles must be defined as follows:
.br
\fIl1p1\fR = {lat11 lon11} = 1st point of 1st great circle
.br
\fIl1p2\fR = {lat12 lon12} = 2nd point of 1st great circle
.br
\fIl2p1\fR = {lat21 lon21} = 1st point of 2nd great circle
.br
\fIl2p2\fR = {lat22 lon22} = 2nd point of 2nd great circle
.sp
Great circles intersect at two points.  The result is the intersection closer
to the average location of the four points.  If the intersection is undefined
(i.e. all the points are on the same great circle), the command raises an
error.
.TP
\fBgeomap::rotatpt\fR \fI{abs ord} theta\fR
Returns point \fI{abs ord}\fR rotated \fItheta\fR degrees clockwise.
.TP
\fBgeomap::scalept\fR \fI{abs ord} factor\fR
Returns \fI{abs ord}\fR scaled by \fIfactor\fR.
.TP
\fBgeomap::domnlat\fR \fIlat\fR
Returns a latitude equivalent to \fIlat\fR in the range -90 <= lat <= 90.  In
this context, equivalent means with the same sine.
.TP
\fBgeomap::domnlon\fR \fIlon rlon\fR
Returns a longitude equivalent to \fIlon\fR but in the domain of \fIrlon\fR.
In other words, it adds or subtracts a multiple of 360 such that
\fIrlon\fR - 180 < lon < \fIrlon\fR + 180.
.TP
\fBgeomap::domnlonpt\fR \fI{lat lon} rlon\fR
Returns a point equivalent to \fI{lat lon}\fR whose longitude is in the domain
of \fIrlon\fR.
.TP
\fBgeomap::gwchlon\fR \fIlon\fR
Equivalent to "\fBdomnlon\fR \fIlon\fR \fB0.0\fR".
.TP
\fBgeomap::gwchpt\fR \fI{lat lon}\fR
Equivalent to "\fBdomnlonpt\fR \fI{lat lon}\fR
\fB0.0\fR".
.TP
\fBgeomap::dmstodec\fR \fI{deg ?min ?sec?? \fBN\fRor\fBS\fI deg ?min ?sec?? \fBW\fRor\fBE\fI}\fR
Returns the decimal representation of an angle or {lat lon} value given in
degree-minute-second representation.  In the result, southern latitudes and
western longitudes will be negative.  The input angle or location must be in
one of the following forms:
.br
\fIdeg min sec \fBN\fRor\fBS\fI deg min sec \fBW\fRor\fBE\fI\fR
.br
\fIdeg min \fBN\fRor\fBS\fI deg min \fBW\fRor\fBE\fI\fR
.br
\fIdeg \fBN\fRor\fBS\fI deg \fBW\fRor\fBE\fI\fR
.br
\fIdeg min sec\fR
.br
\fIdeg min\fR
.TP
\fBgeomap::dectodm\fR \fIdeg\fROR\fI{lat lon}\fR
Returns a list of form {degrees minutes} corresponding to \fIdeg\fR, which must
be an angle given as a decimal value, or it returns a list of form {deg min
NorS deg min WorE} corresponding to \fI{latitude longitude}\fR, which must be a
geographic location given as a pair of decimal values.
.TP
\fBgeomap::dectodms\fR \fIdeg\fROR\fI{lat lon}\fR
Returns a list of form {degrees minutes} corresponding to \fIdeg\fR, which must
be an angle given as a decimal value, or it returns a list of form {deg min
NorS deg min WorE} corresponding to \fI{latitude longitude}\fR, which must be a
geographic location given as a pair of decimal values.
.TP
\fBgeomap::cartg\fR \fI{1:XXXXXXX}\fROR\fIdoubleValue\fR
Returns the floating point representation of a map scale given in cartographic
notation \fI1:XXXXXXX\fR, where \fIXXXXXXXX\fR is number, or it returns the
cartographic representation of a map scale given as a floating point value
\fIdoubleValue\fR.
.TP
\fBgeomap::centroid\fR \fIpoint_list\fR
Returns the mean position of the points in \fIpoint_list\fR, which should be
a list of form {{lat1 lon1} {lat2 lon2} ...}.
.SH TIME
The \fBgeomap::time\fR command does some simple time calculations.  Its
behavior is determined by its first argument.  The following forms are
permitted:
.TP
\fBgeomap::time\fR \fBjul_to_cal\fR {\fIjulian_day second\fR}
Returns a list of form {year month day hour minute second} corresponding to
Julian day \fIjulian_day\fR at time \fIsecond\fR seconds after midnight.
.TP
\fBgeomap::time\fR \fBcal_to_jul\fR {\fIyear month day hour minute second\fR}
Returns a list of form {julian_day seconds} giving the Julian day and time
corresponding to {\fIyear month day hour minute second\fR}.
.TP
\fBgeomap::time\fR \fBincr\fR {\fIyear month day hour minute second\fR} \fIseconds\fR
Adds \fIseconds\fR seconds to {\fIyear month day hour minute second\fR}.  The
result is a list of form {year month day hour minute second}.
.TP
\fBgeomap::time\fR \fBcmp\fR \fItime1\fR \fItime2\fR
Compares two times, given as lists of form {year month day hour minute second}.
Result is \fB-1\fR if \fItime1\fR is earlier than \fItime2\fR.
Result is \fB0\fR if \fItime1\fR is the same time as \fItime2\fR.
Result is \fB1\fR if \fItime1\fR is later than \fItime2\fR.
.TP
\fBgeomap::time\fR \fBdiff\fR \fItime1\fR \fItime2\fR
Returns \fItime1\fR minus \fItime2\fR in seconds.
.SH PROJECTIONS
The \fBgeomap::projection\fR command creates a Tcl command that converts
{latitude longitude} values to projection coordinates and back.  In this
context, projection coordinates specify locations on a two dimensional plane
or surface near the spherical Earth onto which points on the Earth's surface
are projected.  A projection is characterized by a type, given as
\fIprojType\fR, such as Mercator or Orthographic, and additional \fIoptions\fR
which depend on the projection type.
.PP
Projection commands assume a spherical Earth.  Most of the formulas are from
Snyder, John P., Map Projections used by the U.S. Geological Survey.
(Geological Survey bulletin ; 1532) United States Government Printing Office,
Washington:  1982.
.PP
The \fBgeomap::projection\fR returns the name of the new Tcl command that
accesses the projection.  The command name will have form
\fB::geomap::proj\fIx\fR, where \fIx\fR is an integer.  The following
\fIprojType\fR values and \fIoptions\fR are recognized:
.TP
\fBgeomap::projection CylEqDist\fR \fIrefLat refLon\fR
Creates a command that makes conversions with Cylindrical Equidistant projection
with reference latitude \fIrefLat\fR and reference longitude \fIrefLon\fR (i.e.
longitudes will range from \fIrefLon\fR - 180 to\fIrefLon\fR + 180)
.TP
\fBgeomap::projection Mercator\fR \fIrefLon\fR
Creates a command that makes conversions with Mercator projection referenced to
\fIrefLon\fR (i.e. longitudes range from \fIrefLon\fR - 180 to\fIrefLon\fR +
180)
.TP
\fBgeomap::projection CylEqArea\fR \fIrefLon\fR
Creates a command that makes conversions with Cylindrical Equal Area projection
referenced to \fIrefLon\fR (i.e. longitudes range from \fIrefLon\fR - 180
to\fIrefLon\fR + 180)
.TP
\fBgeomap::projection LambertConfConic\fR \fIrefLat refLon\fR
Creates a command that makes conversions with Lambert Conformal Conic projection
with reference latitude \fIrefLat\fR and reference longitude \fIrefLon\fR.
If \fIrefLat\fR is 90 degrees, creates North Polar Stereographic.  If
\fIrefLat\fR is -90 degrees, creates South Polar Stereographic.  If
\fIrefLat\fR is 0, creates Mercator referenced to \fIrefLon\fR.
.TP
\fBgeomap::projection LambertEqArea\fR \fIrefPt\fR
Creates a command that makes conversions with Lambert Azimuthal Equal Area 
projection referenced to \fIrefPt\fR.
.TP
\fBgeomap::projection Stereographic\fR \fIrefPt\fR
Creates a command that makes conversions with Stereographic projection
referenced to \fIrefPt\fR.
.TP
\fBgeomap::projection PolarStereographic\fR \fIN\fR|\fIS\fR
Creates a command that makes conversions with Stereographic projection
referenced to North or South Pole (for argument \fBN\fR or \fBS\fR,
respectively)
.TP
\fBgeomap::projection Orthographic\fR \fIrefPt\fR
Creates a command that makes conversions with Orthographic projection
referenced to \fIrefPt\fR.
.SH PROJECTION COMMANDS
Commands created with \fBgeomap::projection ...\fR accept the following
subcommands.  Here, \fIprojId\fR is the command name returned by the
\fBgeomap::projection\fR command.
.TP
\fIprojId\fR \fBset\fR \fIprojType ?arg ...?\fR
Changes the projType and parameters for the projection.
Types and arguments are same as for \fBgeomap::projection\fR command.
.TP
\fIprojId\fR \fBrotation\fR ?\fIangle\fR?
Without argument, returns the current rotation angle for the projection
If present, \fIangle\fR specifies the projection orientation.  A value of
\fB0.0\fR or \fBnorth\fR means the top of the map is north.  A double value gives
the number of degrees the map is rotated clockwise from the conventional
north-is-up orientation.  A value of \fBnorth\fR, \fBnneast\fR, \fBneast\fR,
\fBeneast\fR, \fBeast\fR, \fBeseast\fR, \fBseast\fR, \fBsseast\fR, \fBsouth\fR,
\fBsswest\fR, \fBswest\fR, \fBwswest\fR, \fBwest\fR, \fBwnwest\fR,
\fBnwest\fR, or \fBnnwest\fR gives the direction at the top of the map.
\fIprojId\fR \fBinfo\fR
Returns a string description of the projection.
The first word is always a projType, that can be used as the first argument to
\fIprojId\fR \fBset\fR or \fBgeomap::projection\fR, followed by the
projection's parameters, if any.
.TP
\fIprojId\fR \fBfmlatlon\fR \fI{lat lon}\fR
Returns {abscissa ordinate} on the projection surface corresponding to
\fI{lat lon}\fR for the projection.
.TP
\fIprojId\fR \fBtolatlon\fR \fI{abscissa ordinate}\fR
Returns the {lat lon} corresponding to projection coordinates
\fI{abscissa ordinate}\fR.
.SH LINEARRAYS
The \fBgeomap::lnarr\fR command creates and manages linearrays.  In this
context, a {lat lon} pair is a geopoint.  A set of geopoints make a geoline.
A set of geolines make a linearray.  They are most often used for drawing
outlines or for drawing large sets of anonymous points.
.sp
The behavior of the \fBgeomap::lnarr\fR command is determined by its first
argument.  The following forms are permitted:
.TP
\fBgeomap::lnarr fmlist\fR \fIlnArrName listValue\fR
Creates a linearray from a list.
.sp
The \fIlistValue\fR can be a list of geopoints, in which case the linearray
has one geoline.  For example,
.br
\fI{{lat1 lon1} {lat2 lon2} {lat3 lon3} {lat4 lon4}}\fR
.br
would be interpreted as a linearray with one geoline of four points.
.sp
More generally, \fIlistValue\fR can contain several lists, each of which
contains the points in a geoline. For example
.br
\fI{{{lat11 lon11} {lat12 lon12} {lat13 lon13} {lat14 lon14}} {{lat21 lon21}
{lat22 lon22} {lat23 lon23}}}\fR
.br
has two geolines, the first with four geopoints, the second with three.
.sp
If successful, \fBgeomap::lnarr fmlist\fR will create a new Tcl command named
\fIlnArrName\fR whose behavior is described in the \fBARRAY COMMAND\fR section
below.
It is important to note that this command will silently delete any previous
command named \fIlnArrName\fR.  \fIlnArrName\fR can have namespace qualifiers
to put it in a namespace.
.sp
The array can be deleted by deleting the \fIlnArrName\fR Tcl command, usually
by changing its name to \fB{}\fR with \fBrename\fR, or by deleting the namespace
that contains the command.
.TP
\fBgeomap::lnarr fmascii\fR \fIlnArrName fileName\fR ?\fB-descrlen\fR \fIlen\fR? ?\fB-format\fR \fIfmt\fR?
Loads a linearray named from an ascii file or process named \fIfileName\fR.
.sp
If the first character of \fIfileName\fR is not \fB|\fR
then the command opens a file.  If the first character of \fIfileName\fR
is \fB|\fR then the  remaining  characters of \fIfileName\fR
are treated as a list of arguments that describe a command pipeline to
invoke, in the same style as the arguments for \fBexec\fR.
.sp
If present, the \fBdescrlen\fR option indicates an amount of data at the start
of the file to put into the new array's descriptor.  If \fIlen\fR
is a number, or number with a \fBb\fR appended to it (e.g. \fB10\fR or
\fB10b\fR) then that number of bytes from the start of the file is given
to the array descriptor.  If \fIlen\fR is a number with an \fBl\fR appended
to it (e.g. \fB10l\fR) then that number of lines from the start of the
file is given to the array descriptor.  The command assumes {lat lon}
values are in the file immediately after the descriptor.
If there is no \fBdescrlen\fR option,
\fBgeomap::lnarr fmascii\fR starts reading line data immediately and the
array's descriptor is an empty string.  An array descriptor can be retrieved
with the '\fIlnArrName\fR \fBdescr\fR' command.
.sp
The line data must take the following form:  for each line, an integer giving
the number of points in the line, and then the points as {lat lon} pairs.
The {lat lon} pairs are read using a "%f %f" format specifier unless the
\fBformat\fR option is present, which must give a format specifier that
directs \fBfscanf\fR to read two float values.
.sp
Reading continues until \fBgeomap::lnarr\fR finishes reading a line and does
not find an integer giving the number of points in another line.  Behavior
is undefined, and probably bad, if there is a mismatch between the integer
count and actual number of points in a line.  
.sp
If successful, \fBgeomap::lnarr fmascii\fR will create a new Tcl command named
\fIlnArrName\fR whose behavior is described in the \fBLINEARRAY COMMAND\fR
section below.
It is important to note that this command will silently delete any previous
command named \fIlnArrName\fR.  \fIlnArrName\fR can have namespace qualifiers
to put it in a namespace.
.sp
The array can be deleted by deleting the \fIlnArrName\fR Tcl command, usually
by changing its name to \fB{}\fR with \fBrename\fR, or by deleting the namespace
that contains the command.
.TP
\fBgeomap::lnarr fmxdr\fR \fIlnArrName fileName\fR
Loads a linearray named \fIlnArrName\fR from an xdr (external data
representation) file or process named \fIfileName\fR.  Xdr is a platform
transparent format for storing strings, integers, and floats.  See the
librpc man page (probably named \fBxdr\fR, \fBrpc\fR, or \fBlibrpc\fR, or
enter \fBman -k xdr\fR) or visit http://www.acc.umu.se/~balp/rpcunix/,
http://www.ietf.org/rfc/rfc1832.txt or similar for more information.  If the
first character of \fIfileName\fR is not \fB|\fR then the command opens a
file.  If the first character of \fIfileName\fR is \fB|\fR then the
remaining  characters of \fBfileName\fR are treated as a list of arguments
that describe a command pipeline to invoke, in the same style as the
arguments for \fBexec\fR.
.sp
The xdr file or process must have the following sequence of xdr records:
.sp
\fBxdr_string\fR: file descriptor, which becomes the array descriptor,
accessible with the '\fIlnArrName\fR \fBdescr\fR' command,
.sp
\fBxdr_integer\fR: number of points in the first geoline,
.sp
\fBxdr_float\fR \fBxdr_float\fR \fBxdr_float\fR \fBxdr_float\fR ... : latitude
longitude values for each point in the first geoline,
.sp
\fBxdr_integer\fR: number of points in the second geoline,
.sp
\fBxdr_float\fR \fBxdr_float\fR \fBxdr_float\fR \fBxdr_float\fR ... : latitude
longitude values for each point in the second geoline,
.sp
and so on...
.sp
Thus, there is an xdr_integer record followed by twice that number of xdr_float
records for each geoline in the linearray.
.sp
All latitude and longitude values in the xdr stream are separate xdr float
records.  None of the values are stored in xdr arrays.
.sp
If successful, \fBgeomap::lnarr fmxdr\fR will create a new Tcl command named
\fIlnArrName\fR, whose behavior is described in the \fBARRAY COMMAND\fR section
below.
It is important to note that this command will silently delete any previous
command named \fIlnArrName\fR.  \fIlnArrName\fR can have namespace qualifiers
to put it in a namespace.
.sp
The array can be deleted by deleting the \fIlnArrName\fR Tcl command, usually
by changing its name to \fB{}\fR with \fBrename\fR, or by deleting the namespace
that contains the command.
.TP
\fBgeomap::lnarr fmbin\fR \fIlnArrName fileName\fR
Loads a linearray named \fIlnArrName\fR from a native binary file or process
named \fIfileName\fR.  The stream should consist of an integer descriptor
length, a descriptor, and then for each line an integer giving the number of
points in the line followed by the latitude-longitude values for the
points as float values.
.sp
If successful, \fBgeomap::lnarr fmbin\fR will create a new Tcl command named
\fIlnArrName\fR, whose behavior is described in the \fBARRAY COMMAND\fR section
below.
It is important to note that this command will silently delete any previous
command named \fIlnArrName\fR.  \fIlnArrName\fR can have namespace qualifiers
to put it in a namespace.
.sp
The array can be deleted by deleting the \fIlnArrName\fR Tcl command, usually
by changing its name to \fB{}\fR with \fBrename\fR, or by deleting the namespace
that contains the command.
.SH LINEARRAY COMMAND
Subcommands that add a linearray to the database also create a Tcl command
named \fIlnArrName\fR to access and manipulate the array.  Its behavior is
determined by the first argument.  The following forms are permitted:
.TP
\fIlnArrName\fR \fBtolist\fR
Returns the linearray named \fIlnArrName\fR as a list in the same format as
read by the \fBfmlist\fR command.
.TP
\fIlnArrName\fR \fBtoascii\fR \fIfileName\fR ?\fB-ptperln\fR \fIn\fR? ?\fB-format\fR \fIformat\fR?
Write a linearray to file \fIfileName\fR as printable text.  The file will
contain the array's descriptor, followed by the lines.  Each line will consist
of an integer giving the number of points in the line printed with "%d " format
followed by the points as {lat lon} pairs.  If present, the \fBptperln\fR
option gives the maximum number of {lat lon} pairs in each line of output,
before a newline is inserted.  The {lat lon} pairs will be printed with
"%f %f " format, unless a different format is specified by the \fIformat\fR
option, which must be a format specifier that directs the C standard library
function \fBfprintf\fR to print two float values.
.TP
\fIlnArrName\fR \fBtoxdr\fR \fIfileName\fR
Sends a linearray to a file named \fIfileName\fR in the same format expected
by the \fBfmxdr\fR subcommand.
.TP
\fIlnArrName\fR \fBtobin\fR \fIfileName\fR
Sends the linearray named \fIlnArrName\fR to a file named \fIfileName\fR
in a a native binary format that can be read by the \fBfmbin\fR subcommand.
.TP
\fIlnArrName\fR \fBinfo\fR
Returns a list containing {{descriptor} {maxLat maxLon minLat minLon}
{number of lines} {total number of points} {number of points in longest line}}
for the linearray.  If a max or min is undefined, it is given as \fBundef\fR.
.TP
\fIlnArrName\fR \fBdescr\fR \fI?newDescriptor?\fR
Without \fInewDescriptor\fR argument, returns the descriptor for the
linearray named \fIlnArrName.\fR  With \fInewDescriptor\fR, sets the
descriptor for array to \fInewDescriptor\fR, and returns the new descriptor.
.TP
\fIlnArrName\fR \fBcontainpt\fR \fIgeopoint\fR
Assume each of the geolines in the linearray named \fIlnArrName\fR is a
simple polygon.  This procedure returns true (\fB1\fR) if \fIgeopoint\fR is
contained in any of these polygons, otherwise returns false (\fB0\fR).
Behavior is undefined if any of the lines cross themselves.
.SH PLACES
The \fBgeomap::place\fR command creates and manipulates places.  In this
context a place is a point on the Earth's surface with a specific {lat lon}
and a name.  Places can be cities, observation stations, and other points of
interest.
.sp
The behavior of the \fBgeomap::place\fR command is determined by its first
argument.  The following forms are permitted:
.TP
\fBgeomap::place new\fR \fIplaceName {lat lon}\fR
This command adds a new place named \fIplaceName\fR to the place
database at \fI{lat lon}\fR.  Return value is \fIplaceName\fR.
It returns an error message if a there is already a command named
\fIplaceName\fR.  If successful, \fBgeomap::place new\fR
will create a new Tcl command \fIplaceName\fR
whose behavior is described in the \fBPLACE COMMAND\fR section.
It is important to note that this command will silently delete any previous
command named \fIplaceName\fR.  \fIplaceName\fR can have namespace qualifiers
to put it in a namespace.
The place can be deleted by removing its command.
.TP
\fBgeomap::place set\fR \fIplaceName ?{lat lon}?\fR
If called without a \fI{lat lon}\fR argument, this command returns the
{lat lon} of the place named \fIplaceName\fR.  If no such place exists,
this command returns an error message.  With
a \fI{lat lon}\fR argument, \fBgeomap::place\fR sets coordinates of a place
named \fIplaceName\fR.  If no place named \fIplaceName\fR exists, a place
with that name and a corresponding command is created, in the same manner as
\fBgeomap::place new\fR.  Any previous command named \fIplaceName\fR is deleted.
.TP
\fBgeomap::place distance\fR \fIplaceName\fROR\fI{lat lon} placeName\fROR\fI{lat lon} ?unit?\fR
Returns the distance between two places or {lat lon} pairs, assuming a
spherical Earth with radius set by the \fBgeoradius\fR
command.  Default distance unit is great circle degrees, unless \fIunit\fR
is specified, which can be \fBnmiles\fR (international standard nautical mile =
1852.0 m), \fBsmiles\fR (statute mile = 1609.344 m), \fBkm\fR (kilometer),
or \fBgsdeg\fR (great circle degrees).
.TP
\fBgeomap::place azrng\fR  \fIplaceName\fROR\fI{lat lon} placeName\fROR\fI{lat lon} ?unit?\fR
Returns {azimuth range} from the first place to the second, assuming a
spherical Earth with radius set by the \fBgeoradius\fR
command.  Range is given in great circle degrees, unless \fIunit\fR
is specified, which can be \fBnmiles\fR (nautical miles), \fBsmiles\fR (statute
miles), \fBkm\fR (kilometers), or \fBgsdeg\fR (great circle degrees).
.TP
\fBgeomap::place nearest\fR \fIplaceName\fROR\fI{lat lon} placeList\fR
Returns the name of the place in placeList nearest the given \fIplaceName\fR or
\fI{lat lon}\fR, assuming a spherical Earth with radius set by the
\fBgeomap::georadius\fR command.
Names in \fIplaceList\fR must refer to commands created by
\fBgeomap::place new\fR or \fBgeomap::place set\fR.
If the place commands are in namespaces, they MUST BE FULLY QUALIFIED.
.TP
\fBgeomap::place step\fR \fIplaceName\fROR\fI{lat lon} bearing range ?unit?\fR
Returns {lat lon} of point at given \fIbearing\fR and \fIrange\fR from the
place named \fIplaceName\fR or the point at coordinates \fI{lat lon}\fR.
\fIBearing\fR can be a number of degrees clockwise from North or one of
\fBnorth nneast neast eneast east eseast seast sseast south sswest swest
wswest west wnwest nwest\fR or \fBnnwest\fR.  Default distance unit is
great circle degrees, unless \fIunit\fR is specified, which can be
\fBnmiles\fR (nautical miles), \fBsmiles\fR (statute miles), \fBkm\fR
(kilometers), or \fBgsdeg\fR (great circle degrees).
.TP
\fBgeomap::place inrange\fR \fIplaceName\fROR\fI{lat lon} {range ?unit?} placeList\fR
Returns a list of places in \fIplaceList\fR
within range of place named \fIplaceName\fR or the point at coordinates
\fI{lat lon}\fR.  Default unit for \fIrange\fR
is great circle degrees, unless \fIrange\fR is given with \fIunit\fR,
which can be \fBnmiles\fR (nautical miles), \fBsmiles\fR (statute miles),
\fBkm\fR (kilometers), or \fBgsdeg\fR (great circle degrees).
Names in \fIplaceList\fR must refer to commands created by
\fBgeomap::place new\fR or \fBgeomap::place set\fR.
If the place commands are in namespaces, they MUST BE FULLY QUALIFIED.
.SH PLACE COMMAND
Subcommands that add a place to the database also create a Tcl command
named \fIplaceName\fR to access and manipulate the place.  Its behavior is
determined by the first argument.  The following forms are permitted:
.TP
\fIplaceName\fR \fBset\fR \fI?{lat lon}?\fR
Without \fI{lat lon}\fR, returns the {lat lon} of the place named
\fIplaceName\fR or an error message if the place does not exist.  With
\fI{lat lon}\fR, sets coordinates of the place.
.TP
\fIplaceName\fR \fBnearest\fR \fIplaceList\fR
Returns the name of the place in \fIplaceList\fR nearest the given
\fIplaceName\fR, assuming a spherical Earth with radius set by the
\fBgeomap::georadius\fR command.
Names in \fIplaceList\fR must refer to commands created by
\fBgeomap::place new\fR or \fBgeomap::place set\fR.
If the place commands are in namespaces, they MUST BE FULLY QUALIFIED.
.TP
\fIplaceName\fR \fBstep\fR \fIbearing range ?unit?\fR
Returns {lat lon} of point at given \fIbearing\fR and \fIrange\fR from the
place named \fIplaceName\fR.
\fIbearing\fR can be a number of degrees clockwise from North or one of
\fBn nne ne ene e ese se sse s ssw sw wsw w wnw nw\fR or \fBnnw\fR.
Default distance unit is great circle degrees, unless
\fIunit\fR is specified, which can be \fBnmiles\fR (nautical miles),
\fBsmiles\fR (statute miles), \fBkm\fR (kilometers), or
\fBgsdeg\fR (great circle degrees).
.TP
\fIplaceName\fR \fBinrange\fR \fI{range ?unit?} placeList\fR
Returns a list of places in \fIplaceList\fR within \fIrange\fR of place
named \fIplaceName\fR.
Default unit for \fIrange\fR is great circle degrees, unless \fIrange\fR is
given with \fIunit\fR, which can be \fBnmiles\fR (nautical miles), \fBsmiles\fR
(statute miles), \fBkm\fR (kilometers), or \fBgsdeg\fR (great circle degrees).
Names in \fIplaceList\fR must refer to commands created by
\fBgeomap::place new\fR or \fBgeomap::place set\fR.
If the place commands are in namespaces, they MUST BE FULLY QUALIFIED.
.SH VARIABLES
Variable \fB::geomap::tclgeomap_lib_file\fR contains the full path name
of the file that provided the \fBtclgeomap\fR package.
.SH FILES
These commands are added to Tcl by the \fBtclgeomap\fR package in file
\fBlibtclgeomap.so\fR or \fBlibtclgeomap.a\fR built by the tclgeomap
distribution.  It is part of the \fBtclgeomap\fR and \fBtkgeomap\fR
executables, or can be added to the current interpreter with the
\fBload\fR or \fBpackage\fR commands.  Run \fBpackage names\fR to determine
if the \fBtclgeomap\fR package is present.  See the tclgeomap
distribution for installation information.
.SH AUTHOR
Gordon Carrie <user0@tkgeomap.org>
