.\"
.\" Copyright (c) 2004 Gordon D. Carrie.  All rights reserved.
.\" 
.\" Licensed under the Open Software License version 2.1
.\" 
.\" Please address questions and feedback to user0@tkgeomap.org
.\" 
.\" @(#) $Id: tclgeomap_procs.n,v 1.9 2007/06/22 22:40:49 tkgeomap Exp $
.\"
.TH tclgeomap n 2 Tk "Tcl Extensions"
.SH NAME
tclgeomap_procs, latitude, longitude, latlon, circle, fillsegment, grid_list, ocean_list \- supplementary procedures for tclgeomap.
.SH VERSION
2
.SH SYNOPSIS
.nf
\fBpackage require tclgeomap_procs\fR ?\fB2\fR?
\fBgeomap::latitude\fR \fIgeoPt\fR
\fBgeomap::longitude\fR \fIgeoPt\fR
\fBgeomap::latlon\fR \fIgeoPt\fR
\fBgeomap::prt_time\fR \fItime\fR \fIyear\fR \fImonth\fR \fIday\fR \fIhour\fR \fIminute\fR \fIsecond\fR
\fBgeomap::circle\fR \fIcenter radius {unit gsdeg}\fR
\fBgeomap::fillsegment\fR \fIp1 p2 {d 2.0}\fR
\fBgeomap::grid_list\fR \fI{s\fR \fB15.0}\fR
\fBgeomap::ocean_list\fR \fI{s\fR \fB15.0}\fR
\fBgeomap::projections\fR
\fBgeomap::proj_info\fI \fIproj_name\fR
.fi
.SH DESCRIPTION
The \fBtclgeomap\fR package provides procedures to use with the tclgeomap.
.SH COMMANDS
.TP
\fBgeomap::latitude\fR \fIgeoPt\fR
This convenience procedure returns the latitude member of \fIgeoPt\fR, which
should be a list of form {lat lon}.
.TP
\fBgeomap::longitude\fR \fIgeoPt\fR
This convenience procedure returns the longitude member of \fIgeoPt\fR, which
should be a list of form {lat lon}.
.TP
\fBgeomap::latlon\fR \fIgeoPt\fR
This procedure returns the geographic point corresponding to \fIgeoPt\fR.
If \fIgeoPt\fR is a {latitude longitude} value, the procedure merely returns
it.  If \fIgeoPt\fR is a location given in degrees, minutes, seconds format,
it returns the corresponding decimal representation.  Otherwise the procedure
raises an error.
.TP
\fBgeomap::prt_time\fR \fItime\fR \fIyear\fR \fImonth\fR \fIday\fR \fIhour\fR \fIminute\fR \fIsecond\fR
This procedures takes time value \fItime\fR, which should be a list of form
{year month day hour minute second} and puts the elements into variables named
\fIyear\fR \fImonth\fR \fIday\fR \fIhour\fR \fIminute\fR \fIsecond\fR.
.TP
\fBgeomap::circle\fR \fIcenter radius {unit gsdeg}\fR
This procedure returns a list of geographic points that define a circle about
geographic point \fIcenter\fR with radius \fIradius\fR.  Optional unit
\fIunit\fR should be a unit value known to the \fBgeoplace step\fR command.
.TP
\fBgeomap::fillsegment\fR \fIp1 p2 {d 2.0}\fR
This procedure returns a list of geographic points on the great circle
connecting geographic points \fIp1\fR and \fIp2\fR that are not further than
\fId\fR great circle degrees apart.  This can be useful for defining long
segments that will assume the correct shape in various map projections.
.TP
\fBgeomap::grid_list\fR {\fIs\fR \fB15.0\fR}
This procedure returns a list of grid lines that cover the Earth.
The returned list is in a format intelligible to the
\fBgeolinearray fmlist ...\fR command.  Spacing \fIs\fR gives the rectangle
size in degrees.
.TP
\fBgeomap::ocean_list\fR {\fIs\fR \fB15.0\fR}
This procedure returns a list of closed rectangles that cover the Earth.
The returned list is in a format intelligible to the
\fBgeolinearray fmlist ...\fR command.  The outlines can be useful for
initializing the globe with a solid color (like blue) and then drawing land
features on top.  Spacing \fIs\fR gives the rectangle size in degrees.
.TP
\fBgeomap::projections\fR
Returns a list of known projections.
.TP
\fBgeomap::proj_info\fR \fIproj_name\fR
Returns a list of form {reference domain}, where reference
is the type of reference projection \fIproj_name\fR uses, either \fBpoint\fR or
\fBlongitude\fR, and domain is how much of the Earth projection \fIproj_name\fR
transforms, either \fBglobe\fR or \fBhemisphere\fR.
.SH FILES
These procedures are part of the \fBtclgeomap_procs\fR
package, which is defined in file \fBtclgeomap_procs.tcl\fR of the tkgeomap
installation.
.SH AUTHOR
Gordon Carrie <user0@tkgeomap.org>
